;-------------------------------------------------------------------------

	include	"doorsos.h"
	include	"graphlib.h"
	include	"userlib.h"

;-------------------------------------------------------------------------
	xdef		_ti89
	xdef		_ti92plus
	xdef    	_main
	xdef		_comment

;-------------------------------------------------------------------------
;-------------------------- PROGRAMME ------------------------------------

_main:
	tst		CALCULATOR			;Test Calculator
	beq		Init				;Calculator=0 (TI89) -> Init
	move.l	#239,x_ligne
	move.l	#67,y_ligne
	move.l	#69,rec_start
	move.l	#125,rec_end
	move.l	#59,recbox_h
	move.l	#68,recbox_y
	move.l	#65,snd_end
	move.l	#235,ligne_max
	move.l	#66,sndbox_h
Init:
	jsr		Present			;Va a la presentation
	jsr		ResetDP			;Go au reset
	move.b	#$ff,exit			;Met exit  ff
Loop:
	jsr		Receive			;Go  Receive
	jsr		Send				;Go  Send
	tst.b		exit				;Si exit=0
	bne		Loop				;alors fin
	rts						;sinon retourne  Loop

;-------------------------------------------------------------------------
;-------------------------------------------------------------------------

Present:						;FONCTION PRESENT
	jsr		graphlib::clr_scr		;Reset de l'cran
	move.w	#2,-(a7)			;Mets la Fonte 2 dans la pile. 
	jsr		doorsos::FontSetSys	;Appelle la routine.
	lea		2(a7),a7			;Reinitialise la pile de 2.
	WriteStr	#23,#1,#1,titre		;Affiche la phrase titre.
	move.w	#0,-(a7)			;Mets la Fonte 0 dans la pile. 
	jsr		doorsos::FontSetSys	;Appelle la routine.
	lea		2(a7),a7			;Reinitialise la pile de 2.
	WriteStr	#110,#15,#1,ver		;Affiche la phrase txt1.
	move.w	#1,-(a7)			;Mets la Fonte 1 dans la pile. 
	jsr		doorsos::FontSetSys	;Appelle la routine.
	lea		2(a7),a7			;Reinitialise la pile de 2.
	WriteStr	#1,#40,#1,txt1		;Affiche la phrase txt1.
	WriteStr	#1,#48,#1,txt2		;Affiche la phrase txt2.
	WriteStr	#1,#56,#1,txt3		;Affiche la phrase txt3.
	WriteStr	#1,#92,#1,email		;Affiche l'email de l'auteur.
	WriteStr	#1,#84,#1,auteur		;Affiche le nom de l'auteur.
	jsr		userlib::idle_loop	;Attend qu'une touche soit pressee.
	rts
	
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------

ResetDP:						;FONCTION RESET
	jsr		doorsos::reset_link	;Reset du port com
	jsr		graphlib::clr_scr		;Reset de l'cran
	move.l	#2,d3				;Pour la couleur de la ligne
	move.l	#0,d0				;Pour x1 de la ligne
	move.l	x_ligne,d2			;Pour x2 de la ligne
	move.l	y_ligne,d1			;Pour y de la ligne
	jsr		graphlib::horiz		;Trace la ligne
	move.l	#1,d6
	move.l	#1,d7
	move.l	rec_start,d4
	move.l	#1,d5
	rts


;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
	
Receive:						;FONCTION RECEIVE
	jsr		ReceiveByte			;Va  la fonction Receive Byte
	tst.b		d1
	beq		RecEnd
	cmp.w		#13,d0			;Si d0=13 (enter)-> incY2
	beq		incY2
	cmp.w		#08,d0			;Si d0=08 (backspace)
	beq		Backspace2
	move.b	d0,Char
	WriteStr	d5,d4,#1,Char		;x,y,style,txt
	addq.l	#6,d5
	cmp.l		ligne_max,d5		;Si x=ligne_max -> incY2
	beq		incY2
 RecEnd:						;LABEL DE FIN DE FONCTION RECEIVE
	rts
 Backspace2:
	cmp.w		#1,d5				;Si d5=1	-> RecEnd
	beq		RecEnd
	sub.w		#6,d5
	move.w	d5,XChar
	move.w	d4,YChar
	jsr		ClearChar
	bra		RecEnd
 incY2:						;FONCTION INCREMENTE PARTIE RECEIVE
	addq.l	#8,d4
 	move.l	#1,d5
	cmp.l		rec_end,d4
	beq		ClrS2
	bra		RecEnd
 ClrS2:						;FONCTION CLEAR PARTIE RECEIVE
	move.w	#0,d0				;Routine pour effacer une partie
	move.l	recbox_y,d1			;de l'cran: sur toute la largeur
	move.l	x_ligne,d2			;(0 239) et sur 67 pixel de hauteur 
	move.l	recbox_h,d3			;(68 124). On appellle la fonction
	move.l	#1,d4				;fill de graphlib
	jsr		graphlib::fill
	move.l	rec_start,d4
	move.l	#1,d5
	WriteStr	d5,d4,#1,Char		;x,y,style,txt
	addq.l	#6,d5
	bra		RecEnd

;-------------------------------------------------------------------------
;-------------------------------------------------------------------------

Send:							;FONCTION SEND
	clr.l		d0
	tst.w		doorsos::kb_vars+$1C
	beq		GetKeyCodeReturn
	move.w	doorsos::kb_vars+$1E,d0
	clr.w		doorsos::kb_vars+$1C
 GetKeyCodeReturn:
	tst.b		d0				;Si d0=0 (rien)-> SendEnd
	beq		SendEnd
	cmp.w		#264,d0			;Si d0=264 (esc)-> LoopEnd
	beq		LoopEnd
	cmp.w		#13,d0			;Si d0=13 (enter)-> incY1
	beq		incY1
	cmp.w		#257,d0			;Si d0=257 (backspace)
	beq		Backspace1
	move.b	d0,Char
	movem.l	d0-d7/a0-a5,-(a7)
	WriteStr	d7,d6,#1,Char		;x,y,style,txt	
	movem.l	(a7)+,d0-d7/a0-a5		; NO REGS DESTROYD
	addq.l	#6,d7
	cmp.l		ligne_max,d7		;Si d7=ligne_max -> incY1
	beq		incY1
 
 SendS:						;FONCTION ENVOI DES DONNEES
	jsr		SendByte			;Utilise la fonction Sendbyte
 SendEnd:						;LABEL DE FIN DE FONCTION SEND
	rts
 Backspace1:
	cmp.w		#1,d7				;Si d7=1	-> RecEnd
	beq		SendEnd
	sub.w		#6,d7
	move.w	d7,XChar
	move.w	d6,YChar
	jsr		ClearChar
	move.w	#08,d0
	bra		SendS
 incY1:						;FONCTION INCREMENTE PARTIE SEND
	addq.l	#8,d6
	move.l	#1,d7
	cmp.l		snd_end,d6
	beq		ClrS1
	bra		SendS
 ClrS1:						;FONCTION CLEAR DE LA PARTIE SEND
	move.w	d4,a4
	move.l	#0,d0				;Routine pour effacer une partie
	move.l	#0,d1				;de l'cran: sur toute la largeur
	move.l	x_ligne,d2			;(0 239) et sur 67 pixel de hauteur 
	move.l	sndbox_h,d3			;(0 66). On appellle la fonction
	move.l	#1,d4				;fill de graphlib
	jsr		graphlib::fill
	move.l	#1,d6
	move.l	#1,d7
	move.w	a4,d4
	WriteStr	d7,d6,#1,Char		;x,y,style,txt
	addq.l	#6,d7
	bra		SendS
 LoopEnd:						;FONCTION SORTIE DE BOUCLE
	move.b	#0,exit
	rts

;-------------------------------------------------------------------------
;----------------------- SUB ROUTINES ------------------------------------
SendByte:
	move.l	a0,-(a7)
	move.b  	d0,sblinkbuf
	move.w 	#1,-(a7)
	pea		sblinkbuf(PC)
	jsr 		doorsos::transmit
	addq		#6,a7
	move.l	(a7)+,a0
	rts
;-------------------------------------------------------------------------

ReceiveByte:
 	movem.l	d2/a0-a1,-(a7)
 	clr.b		rblinkbuf
 	move.w	#1,-(a7)
 	pea		rblinkbuf(PC)
 	jsr 		doorsos::receive
 	addq		#6,a7
	move.l	d0,d1
 	clr.l		d0
 	move.b	rblinkbuf(PC),d0
 	movem.l	(a7)+,d2/a0-a1
 	rts
;-------------------------------------------------------------------------

ClearChar:			
	movem.l	d0-d4,-(a7)
	move.w	XChar,d0
	move.w	YChar,d1
	move.w	#6,d2
	move.w	#8,d3
	move.w	#1,d4
	jsr		graphlib::fill
	movem.l	(a7)+,d0-d4
	rts
;-------------------------------------------------------------------------

;-------------------------------------------------------------------------
;------------------------- VARIABLES -------------------------------------

_comment	dc.b 	"DOORS Term by Laurent BARBIER",0
handle	dc.l	0
rblinkbuf	dc.w	0
sblinkbuf	dc.w	0
Char		dc.b	"X",0
clear		dc.b	0
exit		dc.b	0
XChar		dc.w	0
YChar		dc.w	0
titre		dc.b	"DOORS Terminal",0
ver		dc.b	"Version 1.20",0
txt1		dc.b	"<-         Retour arrire",0
txt2		dc.b	"ENTER      A la ligne",0
txt3		dc.b	"ESC        Quitter",0
auteur	dc.b	"Par Laurent BARBIER",0
email		dc.b	"martien_1998@yahoo.com",0
x_ligne	dc.l	158
y_ligne	dc.l	52
rec_start	dc.l	54
rec_end	dc.l	94
recbox_h	dc.l	51
recbox_y	dc.l	54
snd_end	dc.l	49
sndbox_h	dc.l	51
ligne_max	dc.l	157
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------

	end
